/**
 * Generic version of the Box class. 
 */
public class Box<T> {

    private T t; // T stands for "Type"          

    public void add(T t) {
        this.t = t;
    }

    public T get() {
        return t;
    }

    // metodo generico..... Repare o extends Number. Aceita tudo que  Number e classes inferiores
    // portanto Number  o limite superior (upper bound).
    public <U extends Number> void inspect(U u){
        System.out.println("T: " + t.getClass().getName());
        System.out.println("U: " + u.getClass().getName());
    }

}

